package service

import "go/ast"

var (
	typeDeclarations []*Type
)

type Type struct {
	s *ast.TypeSpec
}

func NewType(s *ast.TypeSpec) *Type {
	return &Type{s: s}
}

func (c *Type) String() (code string) {
	code += "typedef "
	code += handleExpr(c.s.Type)
	code += " "
	code += handleIdentExpr(c.s.Name)
	code += optionallyAddArrayDetails(c.s)
	code += ";"
	return
}

func handleType(s *ast.TypeSpec) (code string) {
	addType(s)
	return
}
func addType(s *ast.TypeSpec) {
	c := NewType(s)
	typeDeclarations = append(typeDeclarations, c)
}
